<template>
  <button :type="htmlType" :style="style" class="btn" :class="classes" :disabled="disabled" @click="$emit('click', $event)" >
    <slot />
  </button>
</template>

<script>
export default {
  name: 'VButton',
  props: {
    type: {
      type: String,
      default: 'default', // ['primary', 'dark', 'warning']
    },
    outLine: {
      type: Boolean,
      default: false,
    },
    htmlType: {
      type: String,
      default: 'button', // ['button', 'submit']
    },
    size: {
      type: String,
      default: 'default', // ['mini', 'default', 'large']
    },
    background: {
      type: Boolean,
      default: true,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    width: {
      type: [String, Number],
      default: '',
    },
    height: {
      type: [String, Number],
      default: '',
    }
  },
  computed: {
    classes() {
      return {
        [`btn__color--${this.type}`]: this.type,
        [`btn__size--${this.size}`]: this.size,
        bg__none: !this.background,
        out__line: this.outLine,
      }
    },
    style() {
      const width = typeof this.width === 'number' ? `${this.width}px` : `${this.width}`
      const height = typeof this.height === 'number' ? `${this.height}px` : `${this.height}`
      return `width: ${width}; height: ${height};`
    }
  },
}
</script>

<style lang="scss">
@import './button.scss';
</style>
